Subject: Re: bug#66647: Installation of RPMs produced by ‘guix pack’ is super slow

From: Maxim Cournoyer <[email-masked]>
Date: Sun, 22 Oct 2023 21:35:18 -0400

Hi,

Ludovic Courtès <[email-masked]> writes:

> Hi!
>
> Maxim Cournoyer <[email-masked]> skribis:
>
>> Ludovic Courtès <[email-masked]> writes:
>
> [...]
>
>>> However, installing those RPMs takes a lot of time.  For example,
>>> installing the RPM for ‘gmsh’ (closure: 596 MiB; thousands of files)
>>> takes ~45mn.
>
> [...]
>
>> What is the OS thy install on?  How do they generate the gmsh package
>> exactly?  Perhaps I still have a RPM-based distro VM to try it with.
>
> They’re targeting CentOS 7 (!).  It’s built with:
>
>   guix pack -f rpm -S /opt/bin=bin -R gmsh

I guess it has to do with that very dated version of rpm, because
testing from a Fedora 37 VM I had at hand, it's fast (42 seconds on my
17 years old Core 2 Duo desktop):

--8<---------------cut here---------------start------------->8---
$ cat /etc/os-release 
NAME="Fedora Linux"
VERSION="37 (Workstation Edition)"
ID=fedora
VERSION_ID=37
VERSION_CODENAME=""
PLATFORM_ID="platform:f37"
PRETTY_NAME="Fedora Linux 37 (Workstation Edition)"
ANSI_COLOR="0;38;2;60;110;180"
LOGO=fedora-logo-icon
CPE_NAME="cpe:/o:fedoraproject:fedora:37"
DEFAULT_HOSTNAME="fedora"
HOME_URL="https://fedoraproject.org/"
DOCUMENTATION_URL="https://docs.fedoraproject.org/en-US/fedora/f37/system-administrators-guide/"
SUPPORT_URL="https://ask.fedoraproject.org/"
BUG_REPORT_URL="https://bugzilla.redhat.com/"
REDHAT_BUGZILLA_PRODUCT="Fedora"
REDHAT_BUGZILLA_PRODUCT_VERSION=37
REDHAT_SUPPORT_PRODUCT="Fedora"
REDHAT_SUPPORT_PRODUCT_VERSION=37
VARIANT="Workstation Edition"
VARIANT_ID=workstation

[user@fedora Downloads]$ sudo time rpm -i 7m01b0308z5y2pmyn8ywzdj914dxawsl-gmsh-rpm-pack.rpm
17.26user 10.19system 0:42.31elapsed 64%CPU (0avgtext+0avgdata 24468maxresident)k
1481136inputs+2177344outputs (19major+6242minor)pagefaults 0swaps

[user@fedora Downloads]$ rpm --version
RPM version 4.18.0
--8<---------------cut here---------------end--------------->8---

Perhaps using guix time-machine to a commit where we had a RHEL 7 era
rpm version (4.11 according to [0]) would be faster than installing
Centos 7 in a VM... :-)  except, hm, no, that's way too old.  The oldest
we've got is:

e3e1ecf67c0 (Ludovic Courtès              2015-10-26 290)     (version
"4.12.0")

from 2015...

I don't think I'll be looking at fixing this use case; hopefully they
can retire their CentOS 7 soon (EOL: June 30th 2024) and use something
newer.

I'm tempted to close this as 'wontfix'.  What do you think?

[0]  https://rpmfind.net/linux/rpm2html/search.php?query=rpm&submit=Search+...

-- 
Thanks,
Maxim